--
-- greenFertilizer
-- 
-- 
--
-- upsideDown 19.12.2013

greenFertilizer = {};
addModEventListener(greenFertilizer);
function greenFertilizer.prerequisitesPresent(specializations)
    return true;
end;

function greenFertilizer:loadMap(name)
	print("--- loading greenFertilizer mod V0.9 PUBLIC BETA--- (by upsidedown)")
		
	greenFertilizer.oldUpdateCultivatorArea = Utils.updateCultivatorArea;
	Utils.updateCultivatorArea = greenFertilizer.updateCultivatorArea;
	
	greenFertilizer.oldUpdateSowingArea = Utils.updateSowingArea;
	Utils.updateSowingArea = greenFertilizer.updateSowingArea;
	
	greenFertilizer.oldUpdatePloughArea = Utils.updatePloughArea;
	Utils.updatePloughArea = greenFertilizer.updatePloughArea;
	
	
	
	
	greenFertilizer.fruitData = {};
	greenFertilizer.initDone = false;
end;

function greenFertilizer:deleteMap()
end


function greenFertilizer:mouseEvent(posX, posY, isDown, isUp, button)
end;

function greenFertilizer:keyEvent(unicode, sym, modifier, isDown)
end;


function greenFertilizer:update(dt)
	
	if not greenFertilizer.initDone then
		local fruits = {FruitUtil.FRUITTYPE_KLEE, FruitUtil.FRUITTYPE_LUZERNE, FruitUtil.FRUITTYPE_RAPE}    
		local fruitData = {}
		local cnt = 1;
		for _,subFruit in pairs(fruits) do
			local ids = g_currentMission.fruits[subFruit]
			if ids == nil or ids.id == 0 then
				
			else
				local id = ids.id
				local desc = FruitUtil.fruitIndexToDesc[subFruit];
				fruitData[cnt] = {};
				fruitData[cnt].desc = desc;
				fruitData[cnt].id = id;
				cnt = cnt + 1;
			end;
		end;
		greenFertilizer.fruitData = fruitData;
		greenFertilizer.initDone = true;
		print(tostring(cnt-1).." fruits added to cultivator, plough and direct seeder for fertilizer use")
	end;
end


function greenFertilizer:draw()   
end;


function greenFertilizer.updateCultivatorArea(startWorldX, startWorldZ, widthWorldX, widthWorldZ, heightWorldX, heightWorldZ, forced, commonForced, angle)
	local detailId = g_currentMission.terrainDetailId;
	for _,fruit in pairs(greenFertilizer.fruitData) do
		local x_n, z_n, widthX, widthZ, heightX, heightZ = Utils.getXZWidthAndHeight(fruit.id, startWorldX, startWorldZ, widthWorldX, widthWorldZ, heightWorldX, heightWorldZ)
		setDensityMaskParams(detailId, "between", fruit.desc.minHarvestingGrowthState, fruit.desc.cutState)
		spraySum = setDensityMaskedParallelogram(detailId, x_n, z_n, widthX, widthZ, heightX, heightZ, g_currentMission.sprayChannel, 1, fruit.id, 0, g_currentMission.numFruitStateChannels, 1)
		setDensityMaskParams(detailId, "greater", 0)
	end;
	
	local area = greenFertilizer.oldUpdateCultivatorArea(startWorldX, startWorldZ, widthWorldX, widthWorldZ, heightWorldX, heightWorldZ, forced, commonForced, angle);
	return area;
end;

function greenFertilizer.updatePloughArea(startWorldX, startWorldZ, widthWorldX, widthWorldZ, heightWorldX, heightWorldZ, forced, commonForced, angle)
	local detailId = g_currentMission.terrainDetailId;
	for _,fruit in pairs(greenFertilizer.fruitData) do
		local x_n, z_n, widthX, widthZ, heightX, heightZ = Utils.getXZWidthAndHeight(fruit.id, startWorldX, startWorldZ, widthWorldX, widthWorldZ, heightWorldX, heightWorldZ)
		setDensityMaskParams(detailId, "between", fruit.desc.minHarvestingGrowthState, fruit.desc.cutState)
		spraySum = setDensityMaskedParallelogram(detailId, x_n, z_n, widthX, widthZ, heightX, heightZ, g_currentMission.sprayChannel, 1, fruit.id, 0, g_currentMission.numFruitStateChannels, 1)
		setDensityMaskParams(detailId, "greater", 0)
	end;
	
	local area = greenFertilizer.oldUpdatePloughArea(startWorldX, startWorldZ, widthWorldX, widthWorldZ, heightWorldX, heightWorldZ, forced, commonForced, angle);
	return area;
end;



function greenFertilizer.updateSowingArea(fruitId, startWorldX, startWorldZ, widthWorldX, widthWorldZ, heightWorldX, heightWorldZ, angle, useDirectPlanting)
	local detailId = g_currentMission.terrainDetailId;
	if useDirectPlanting then --direct seeding into intermediate fruit		
		for k,fruit in pairs(greenFertilizer.fruitData) do			
			local x_n, z_n, widthX, widthZ, heightX, heightZ = Utils.getXZWidthAndHeight(fruit.id, startWorldX, startWorldZ, widthWorldX, widthWorldZ, heightWorldX, heightWorldZ)
			setDensityMaskParams(detailId, "between", fruit.desc.minHarvestingGrowthState , fruit.desc.cutState)
			spraySum = setDensityMaskedParallelogram(detailId, x_n, z_n, widthX, widthZ, heightX, heightZ, g_currentMission.sprayChannel, 1, fruit.id, 0, g_currentMission.numFruitStateChannels, 1)
			setDensityMaskParams(detailId, "greater", 0)
		end;
   end;
	
	
	local numPixels, numDetailPixels = greenFertilizer.oldUpdateSowingArea(fruitId, startWorldX, startWorldZ, widthWorldX, widthWorldZ, heightWorldX, heightWorldZ, angle, useDirectPlanting);
	return numPixels, numDetailPixels
end;